/**
 * 
 */
package org.ajax4jsf.portlet.application;

import javax.faces.application.StateManager;
import javax.faces.application.StateManager.SerializedView;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

import org.ajax4jsf.application.AjaxStateManager;

/**
 * @author asmirnov
 *
 */
public class PortalStateManager extends AjaxStateManager {
    
    private static final String VIEW_STATES_MAP = PortalStateManager.class.getName();
    
    private ComponentsLoader componentLoader;
    /**
     * 
     */
    public PortalStateManager(StateManager parentStateManager) {
	super(parentStateManager);
	componentLoader = new ComponentsLoaderImpl();
    }

    /* (non-Javadoc)
     * @see javax.faces.application.StateManager#restoreView(javax.faces.context.FacesContext, java.lang.String, java.lang.String)
     */
    public UIViewRoot restoreView(FacesContext context, String viewId,
	    String renderKitId) {
	    UIViewRoot viewRoot = null;
	if(isSavingStateInClient(context)){
	    viewRoot = super.restoreView(context, viewId, renderKitId);
	} else {
	    PortletStateHolder portletStateHolder = PortletStateHolder.getInstance(context);
	    PortletWindowStates windowStates = portletStateHolder.getWindowStates(context);
	    PortletViewState viewState = windowStates.getState(viewId);
	    viewRoot = viewState.restore(context,componentLoader);
	}
	// TODO - implement portal-specific view state.
	    return viewRoot;
	
    }
    
    public SerializedView saveSerializedView(FacesContext context) {
	SerializedView serializedView = null;
	if(isSavingStateInClient(context)){
	    serializedView = super.saveSerializedView(context);
	} else {
		// TODO - implement portal-specific view state saving.
	    PortletStateHolder portletStateHolder = PortletStateHolder.getInstance(context);
	    PortletWindowStates windowStates = portletStateHolder.getWindowStates(context);
	    String viewId = context.getViewRoot().getViewId();
	    windowStates.setViewId(viewId);
	    PortletViewState viewState = windowStates.getState(viewId);
	    viewState.save(context);
	    serializedView=new SerializedView(viewId,null);
	}
	return serializedView;
    }
    
}
