/**
 * 
 */
package org.ajax4jsf.portlet.application;

import java.io.Serializable;
import java.util.Map;

import org.apache.commons.collections.map.LRUMap;

/**
 * @author asmirnov
 *
 */
public class PortletWindowStates implements Serializable {

    /**
     * 
     */
    private static final long serialVersionUID = 3239697059998528947L;

    private String viewId;
    
    private Map viewStates;
    
    public PortletWindowStates() {
	viewStates = new LRUMap();
    }

    /**
     * @return the viewId
     */
    public String getViewId() {
        return viewId;
    }

    /**
     * @param viewId the viewId to set
     */
    public void setViewId(String viewId) {
        this.viewId = viewId;
    }
    
    public PortletViewState getState(String viewId) {
	PortletViewState state = (PortletViewState) viewStates.get(viewId);
	if(null == state){
	    state = new PortletViewState();
	    viewStates.put(viewId, state);
	}
	return state;
    }
}
